routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Nos mostrará el formulario de login.
Route::get('/', 'Auth\LoginController@showLogin');

// Validamos los datos de inicio de sesión.
Route::post('/validar', 'Auth\LoginController@validarLogin');

    // Esta será nuestra ruta de bienvenida.
Route::get('dashboard', 'DashboardController@index');
Route::get('/busqueda/{busqueda}', 'DashboardController@busquedaTicket');
Route::get('/resultados', 'DashboardController@busqueda')->name('ticket.busqueda');


    // Esta será nuestra ruta de bienvenida.
Route::post('dashboard', 'DashboardController@indexFecha');
    // Esta ruta nos servirá para cerrar sesión.
Route::get('logout', 'Auth\LoginController@logOut');

    //Esta ruta es para crear cliente
    Route::resource('cliente', 'ClienteController');
    //ruta para desactivar y activar clientes
    Route::get('cliente/desactivar/{id}', 'ClienteController@desactivar');
    Route::get('cliente/activar/{id}', 'ClienteController@activar');

    //Rutas para marcas
    Route::resource('marca', 'MarcaController');
    //ruta para desactivar y activar marca
    Route::get('marca/desactivar/{id}', 'MarcaController@desactivar');
    Route::get('marca/activar/{id}', 'MarcaController@activar');
    Route::get('marca/validateNombre/{nombre}', 'MarcaController@validateNombre');

    //Esta ruta es para crear rma
    Route::resource('rma', 'RmaController');
    Route::get('/archivadosrma', 'RmaController@indexArchivados')->name('archivados');
    //Esta ruta es para crear rma
    Route::get('rma/historial/{id}', 'RmaController@historial');
    //ruta para formulario de entrada
    Route::get('entrada', 'RmaController@createE');
    //ruta para formulario de salida
    Route::get('salida', 'RmaController@createS');

    //Rutas para usuarios
    Route::resource('usuario', 'UsuarioController');
    //ruta para desactivar y activar usuario
    Route::get('usuario/desactivar/{id}', 'UsuarioController@desactivar');
    Route::get('usuario/activar/{id}', 'UsuarioController@activar');
    Route::get('usuario/validateUsername/{username}', 'UsuarioController@validateUsername');
    Route::get('usuario/validateCorreo/{email}', 'UsuarioController@validateCorreo');

    //Rutas para empresas
    Route::resource('empresa', 'EmpresaController');
    //ruta para desactivar y activar empresa
    Route::get('empresa/desactivar/{id}', 'EmpresaController@desactivar');
    Route::get('empresa/activar/{id}', 'EmpresaController@activar');
    Route::get('empresa/validateNombre/{nombre}', 'EmpresaController@validateNombre');


    //Esta ruta es para crear prioridades
    Route::resource('prioridad', 'PrioridadController');
    Route::get('prioridad/validateNombre/{nombre}', 'PrioridadController@validateNombre');

    //Esta ruta es para crear tipos de contrato
    Route::resource('tipoContrato', 'TipoContratoController');
    //ruta para desactivar y activar empresa
    Route::get('tipoContrato/desactivar/{id}', 'TipoContratoController@desactivar');
    Route::get('tipoContrato/activar/{id}', 'TipoContratoController@activar');
    Route::get('tipoContrato/validateNombre/{nombre}', 'TipoContratoController@validateNombre');

    //Esta ruta es para crear contratos
Route::resource('contrato', 'ContratoController');
    //Esta ruta es para crear Ticekts
Route::resource('ticket', 'TicketController');

Route::get('/seleccionarCliente/{id}/{emmpresa}', 'ClienteController@seleccion');
Route::get('/unSeleccionarCliente/{id}/{empresa}', 'ClienteController@unSeleccion');
Route::delete('/eliminar_ticket/{id}', 'TicketController@eliminarTicket')->name('ticket.eliminar');
Route::get('/RecordatorioCorreo', 'MailRememberController@recordarRespuesta');//ruta para correos persistentes de recordatorio de respuesta
    //Ruta para obtener todos los mails ingresados por correo
    Route::get('/mails', 'TicketController@tickets_mails');

    //Ruta para obtener todos los mails ingresados por correo
    Route::get('/todos', 'TicketController@allTickets');
        //Esta ruta es para ver los tickets ingresados validados
    Route::get('/ingresados', 'TicketController@tickets_ingresados');
        //Esta ruta es para ver los tickets ingresados que estan en revision
    Route::get('/revision', 'TicketController@tickets_revision');
        //Esta ruta es para ver los tickets ingresados que estan en revision
    Route::get('/proceso', 'TicketController@tickets_proceso');
        //Esta ruta es para ver los tickets ingresados que estan en revision
    Route::get('/respuesta', 'TicketController@tickets_respuesta');
        //Esta ruta es para ver los tickets ingresados que estan en revision
    Route::get('/cerrado', 'TicketController@tickets_cerrado');
    // tickets re abiertos
    Route::get('/re-abierto', 'TicketController@tickets_reabierto');

    //Esta ruta es para crear Ticekts
Route::post('/estadoTicket', 'TicketController@updateHistorico');
    //Esta ruta es para ver los tickets archivados
Route::get('/ticketArchivados', 'TicketController@archivados');
    //Esta ruta es para ver los tickets ingresados por correo
Route::get('/ticketMail', 'TicketController@indexMails');
    //Ruta para validar ticket desde el correo
Route::get('validar/{id}', 'TicketController@validar');
//valida i el ticketya esta siendo trabajado
Route::get('trabajoTicket/{id}', 'TicketController@insertarTiempoInicio');
    //Ruta para enviar correos
Route::get('mail/send', 'TicketController@send');
    //Ruta para enviar correos
Route::get('mail', 'TicketControllmailer@send1');
    //Ruta para enviar correos
Route::get('send', 'TicketController@enviar');
    // ruta para exportar pdf
Route::get('/customers/pdf','ClienteController@export_pdf');
    // ruta para obtener el listado de notificaciones
Route::get('listaNotificaciones', 'TicketController@notificaciones');

    // ruta para obtener el listado de ticket programados
Route::get('listaProgramados', 'RecordarNotificacionesController@programados');
    // ruta para obtener el listado de ticket programados por frecuencia
Route::get('/ticketProgramado', 'RecordarNotificacionesController@ticketFrecuencia');
    // ruta para obtener el listado de ticket programados
Route::get('listadoAbiertos', 'TicketController@listaAbiertos');
Route::get('/actualizarVistos', 'TicketController@actualizarVisto');

Route::get('notificacionesSistema', 'TicketController@notificacionesSistema');
Route::get('/notificacionVista/{id}', 'TicketController@actualizarNotificacionesVista');
Route::get('/notificacionVistaTecnico/{id}', 'TicketController@actualizarNotificacionesVistaTecnico');

    // ruta para actualizar el tiempo
Route::get('updateTiempo/{id}/{tiempo}', 'TicketController@updateTiempo');

Route::get('select_clientes/{id}', 'TicketController@clientes');
Route::get('select_info/{id}', 'TicketController@cliente_info');



Auth::routes();

app/Marca.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Marca extends Model
{
     /**
     * The table associated with the model.
     * 
     * @var string
     */
    protected $table = 'marca';

    /**
     * The primary key for the model.
     * 
     * @var string
     */
    protected $primaryKey = 'idmarca';
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = ['nombre','estado	','created_at','updated_at'];

    public function is_delete(){
        $rma = $this->hasMany('App\Rma','marca','idmarca')->count();

        if ($rma) {
            return false;
        }else{
            return true;
        }
    }
}

app/Http/Controllers/MarcaController.php
<?php

namespace App\Http\Controllers;

use App\Marca;
use Illuminate\Http\Request;

class MarcaController extends Controller
{
    public function __construct() { 
        $this->middleware('preventBackHistory');
        $this->middleware('auth'); 
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $marcas = Marca::orderBy('idmarca','DESC')->get();

        return view('Marca.index',compact('marcas')); 
    }
    
    public function validateNombre($nombre){
        $marca = Marca::where('nombre',$nombre)->count();

        if($marca){ return 1; }else{ return 0; }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('Marca.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request,[
            'nombre' => 'required|string|unique:marca,nombre', 
            'estado' => 'required|int|min:1'
        ]);

        $marca = new Marca();

        $marca->nombre = $request->nombre;
        $marca->estado = $request->estado;

        if ( $marca->save() ) {
            return redirect()->route('marca.index')->with('success','Registro creado satisfactoriamente');
        }else{
            return redirect()->route('marca.index')->with('danger','Registro creado satisfactoriamente');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Marca  $marca
     * @return \Illuminate\Http\Response
     */
    public function show(Marca $marca)
    {
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Marca  $marca
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $marca = Marca::find($id);
        return view('Marca.edit',compact('marca'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Marca  $marca
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request,$id)
    {
        $this->validate($request,[
            'nombre' => 'required|string', 
            'estado' => 'required|int|min:1'
        ]);

        $marca = Marca::find($id);

        $marca->nombre = $request->nombre;
        $marca->estado = $request->estado;

        if ( $marca->save() ) {
            return redirect()->route('marca.index')->with('success','Registro actualizado exitosamente');
        }else{
            return redirect()->route('marca.index')->with('danger','Registro actualizado exitosamente');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Marca  $marca
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Marca::find($id)->delete();
        return redirect()->route('marca.index')->with('success','Registro eliminado satisfactoriamente');
    }

    public function desactivar($id)
    {
        //
        $marca = Marca::find($id);

        $marca->estado = 2;

        $marca->save();

        return redirect()->route('marca.index')->with('success','Marca deshabilitada');
    }

    public function activar($id)
    {
        //
        $marca = Marca::find($id);

        $marca->estado = 1;

        $marca->save();

        return redirect()->route('marca.index')->with('success','Marca Activada');
    }
}

resources/views/Marca/create.blade.php
@extends('Layout.layout')
@section('content')
<div id="base">
<div class="row">
	<section class="content" id="content">

		<div class="col-md-8 col-md-offset-2">
			<div class="section-header">
	            <ol class="breadcrumb">
	               <li><a href="{{ route('marca.index') }}">Lista de Marcas</a></li>
	              <li class="active">Nueva Marca</li>
	            </ol>
          	</div>
			@if (count($errors) > 0)
			<div class="alert alert-danger">
				<strong>Error!</strong> Revise los campos obligatorios.<br>
			</div>
			@endif
			@if(Session::has('success'))
			<div class="alert alert-info">
				{{Session::get('success')}}
			</div>
			@endif

			<div class="panel panel-default">
				<div class="panel-heading">
					<h3 class="panel-title">Nueva Marca</h3>
				</div>
				<div class="panel-body">
					<div class="table-container">
						<form method="POST" action="{{ route('marca.store') }}"  role="form" id="accion_form">
							{{ csrf_field() }}
							<div class="row">
								<div class="col-xs-6 col-sm-6 col-md-6">
									<div class="form-group">
										<label>Nombre</label>
										<input type="text" name="nombre" id="nombre" value="{{ old('nombre') }}" class="form-control input-sm" >
										<p style="color: red;" id="text-nombre">{{ $errors->first('nombre') }}</p>
									</div>
								</div>
								<div class="col-xs-6 col-sm-6 col-md-6">
									<div class="form-group">
										<label for="estado">Estado</label>
										<select id="estado" name="estado" class="form-control">
											<option value="1">Activo</option>
											<option value="2">Inactivo</option>
										</select>
									</div>
								</div>
								<p style="color: red;">{{ $errors->first('estado') }}</p>
							</div>

							<div class="row" align="center">

								<div class="col-xs-6 col-sm-6 col-md-6 col-md-offset-3">
									<input type="submit"  value="Guardar" class="btn btn-success btn-block">
								</div>

							</div>
						</form>
					</div>
				</div>

			</div>
		</div>
	</section>
</div>
@endsection

@section('script')
<script>
	$("#nombre").on("keyup", function(){
		if ($(this).val() == "") {
			$('#text-nombre').text('Campo requerido')
		}else{
			$('#text-nombre').text('');
			$.ajax({
				type: 'GET',
				url: '/marca/validateNombre/'+$('#nombre').val(),
				data: $(this).serialize(),
				success: function(data) {
					if (data == 1){
						$('#text-nombre').text('La marca ya existe');
					}else{
						$('#text-nombre').text('');
					}
				}
			});
		}
	});
</script>

<script src="{{ asset('js/notify.js')}}"></script>
<script src="{{ asset('js/notificaciones.js')}}"></script>
@endsection

resources/views/Marca/edit.blade.php
@extends('Layout.layout')
@section('content')
<div id="base">
    <div class="row">
        <section class="content" id="content">

            <div class="col-md-8 col-md-offset-2">
                <div class="section-header">
                    <ol class="breadcrumb">
                        <li><a href="{{ route('prioridad.index') }}">Lista de Marcas</a></li>
                        <li class="active">Nueva Marca</li>
                    </ol>
                </div>
                @if (count($errors) > 0)
                <div class="alert alert-danger">
                    <strong>Error!</strong> Revise los campos obligatorios.<br>
                </div>
                @endif
                @if(Session::has('success'))
                <div class="alert alert-info">
                    {{Session::get('success')}}
                </div>
                @endif

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Nueva Marca</h3>
                    </div>
                    <div class="panel-body">
                        <div class="table-container">
                            <form method="POST" action="{{ route('marca.update',$marca->idmarca) }}" role="form"
                                id="accion_form">
                                {{ csrf_field() }}
                                <input name="_method" type="hidden" value="PATCH">
                                <div class="row">
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">
                                            <label>Nombre</label>
                                            <input type="text" name="nombre" value="{{ $marca->nombre }}"
                                                class="form-control input-sm">
                                            <p style="color: red;">{{ $errors->first('nombre') }}</p>
                                        </div>
                                    </div>
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">
                                            <label for="estado">Estado</label>
                                            <select id="estado" name="estado" class="form-control">
                                                <option value="1" <?php if ($marca->estado == 1): ?> selected
                                                    <?php endif ?>>Activo</option>
                                                <option value="2" <?php if ($marca->estado == 2): ?> selected
                                                    <?php endif ?>>Inactivo</option>
                                            </select>
                                        </div>
                                    </div>
                                    <p style="color: red;">{{ $errors->first('estado') }}</p>
                                </div>

                                <div class="row" align="center">

                                    <div class="col-xs-6 col-sm-6 col-md-6 col-md-offset-3">
                                        <input type="submit" value="Guardar" class="btn btn-success btn-block">
                                    </div>

                                </div>
                            </form>
                        </div>
                    </div>

                </div>
            </div>
        </section>
    </div>

    <script src="{{ asset('js/notify.js')}}"></script>
    <script src="{{ asset('js/notificaciones.js')}}"></script>
    @endsection

resources/views/Marca/index.blade.php
@extends('Layout.layout')
@section('content')
<!-- BEGIN BASE-->
<div id="base">
<div class="row">
  <section class="content" id="content">
  @if(Session::has('success'))
        <div class="alert alert-info">
          {{Session::get('success')}}
        </div>
      @endif
    <div class="col-md-12">
      <div class="panel panel-default">
        <div class="panel-body">
        <div class="row">
            <div class="col-md-12">
              <div class="pull-left"><h3>Lista de Marcas</h3></div>
              <div class="pull-right">
                <div class="btn-group">
                  <a href="{{ route('marca.create') }}" class="btn btn-info" >Crear Marca</a>
                </div>
              </div>
            </div>
          </div>
          <div class="row">
            <div class="col-md-12">
              <div class="">
                <div class="table-responsive">
                  <table id="example" class="display nowrap" width="100%">
                    <thead>
                      <th>Nombres</th>
                      <th>Estado</th>
                      <th class="no-sort">Acciones</th>
                    </thead>
                    <tbody>
                      @if($marcas->count())
                        @foreach($marcas as $marca)
                          <tr>
                            <td id="marca-{{$marca->idmarca}}">{{$marca->nombre}}</td>
                            <td width="50%">
                              @if($marca->estado == 1)
                                Activo
                              @else
                                Inactivo
                              @endif
                            </td>
                            <td>
                              <div class="row">
                                <div class="col-md-4 col-xs-4">
                                  <a class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" data-original-title="Editar Prioridad" href="{{action('MarcaController@edit', $marca->idmarca)}}" ><span class="glyphicon glyphicon-pencil"></span></a>
                                </div>
                                <div class="col-md-4 col-xs-4">
                                  @if($marca->estado == 1)
                                    <a onclick="act_inac({{$marca->idmarca}},0)" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" data-original-title="Desactivar Marca">
                                      <span class="md md-block"></span>
                                    </a>
                                  @else
                                    <a onclick="act_inac({{$marca->idmarca}},1)" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" data-original-title="Activar Marca">
                                      <span class="md md-check"></span>
                                    </a>
                                  @endif
                                </div>
                                @if($marca->is_delete())
                                <div class="col-md-4 col-xs-4">
                                  <form action="{{action('MarcaController@destroy', $marca->idmarca)}}" onclick="borrar(event,this)" method="post">
                                    {{csrf_field()}}
                                    <input name="_method" type="hidden" value="DELETE">
                                    <button class="btn btn-danger btn-xs" data-toggle="tooltip" data-placement="top" data-original-title="Eliminar Marca" type="submit"><span class="glyphicon glyphicon-trash"></span></button>
                                  </form>
                                </div>
                                @endif
                              </div>
                            </td>
                          </tr>
                        @endforeach
                      @else
                        <tr>
                          <td colspan="8">No hay registro !!</td>
                        </tr>
                      @endif
                    </tbody>
                  </table>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</div>

@endsection

@section('script')
<script src="https://code.jquery.com/jquery-3.3.1.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/buttons/1.5.2/js/dataTables.buttons.min.js"></script>
<script src="https://cdn.datatables.net/buttons/1.5.2/js/buttons.flash.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/pdfmake.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/vfs_fonts.js"></script>
<script src="https://cdn.datatables.net/buttons/1.5.2/js/buttons.html5.min.js"></script>
<script src="https://cdn.datatables.net/buttons/1.5.2/js/buttons.print.min.js"></script>
<script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
<script src="{{ asset('js/notify.js')}}"></script>
<script src="{{ asset('js/notificaciones.js')}}"></script>
<script>
  $('#example').DataTable( {
      dom: 'Bfrtip',
      buttons: [],
      "columnDefs": [{ targets: 'no-sort', orderable: false }],
      "language": {
        "search": "Buscar:",
        paginate: {
          next: '&#8594;', // or '→'
          previous: '&#8592;' // or '←'
        }
      },
      "order": [[ 0, "desc" ]]
    } );

  function borrar(e,form){
    e.preventDefault();
    swal({
      title: "Confirmar eliminación de registro?",
      icon: "warning",
      buttons: ["Confirmar", "Cancelar"],
      dangerMode: true,
    }).then((willDelete) => {
      if (!willDelete) {
        form.submit();
      } else {
        return false;
      }
    });
  }

  function act_inac(id,value){
    var title = 'Activar';
    var url   = 'activar';
    if (!value) {
      title = 'Desactivar';
      url   = 'desactivar';
    }
    swal({
      title: 'Está usted seguro de '+title+' la marca "'+ $('#marca-'+id).text() +'"?',
      icon: "warning",
      buttons: ["Confirmar", "Cancelar"],
      dangerMode: true,
    }).then((willDelete) => {
      if (!willDelete) {
        window.location.href = "/marca/"+url+'/'+id;
      } else {
        return false;
      }
    });
  }
</script>
@endsection